"use strict";
/**
 * 未使用
 */
(function(){
    if(!window.TypeWriter) {
        const TW_EVENT_END="typeWriterEnd";
        var getStyle = function(a,b) {
            if(b==null) {
                b="";
            }
            if(window.getComputedStyle) {
                return window.getComputedStyle(a,b);
            } else if(document.defaultView && document.defaultView.getComputedStyle) {
                return document.defaultView.getComputedStyle(a,b);
            }
        }
        var f = function(sel, opt) {
            if(opt==null) {
                opt = {}
            }
            this.selector = sel;
            this.elm = document.querySelector(sel);
            this.currentLine = 0;
            this.random = typeof opt.random == "undefined" ? true : opt.random;
            this.speed = opt.speed || 300;
            this.pause = opt.pause || 2000;
            this.loop = typeof opt.loop == "undefined" ? false : opt.loop;
            this.effect = opt.effect || {};
            this.opt = opt;
            this.cursor = document.createElement('span');
            this.cursor.classList.add('tw_cursor');
            if(this.opt.cursor && this.opt.cursor.color) {
                this.cursor.style.backgroundColor = this.opt.cursor.color;
            } else {
                this.cursor.style.backgroundColor = getStyle(this.elm, 'color');
            }
            if(this.opt.cursor && this.opt.cursor.width) {
                this.cursor.style.width = this.opt.cursor.width;
            }

            return this.init();
        }

        f.prototype = {
            init: function() {
                return this;
            },
            readLine: function() {
                if(this.elm == null) {
                    return this;
                }

                var nodes = this.elm.childNodes;
                var count = nodes.length;
                var row = 0;
                line = [];

                for(let i = 0; i < count; i++) {
                    let node = nodes[i];
                    if(!line[row]) {
                        line[row] = [];
                    }
                    if(node.nodeName.toUpperCase() == "BR") {
                        row++;
                        continue;
                    }
                    if(node.length == 0) {
                        continue;
                    }
                    line[row].push(node.cloneNode(true));
                }

                return line;
            },
            type: function(line) {
                let self = this;
                let row = line[this.currentLine];
                let lineCount = line.length;

                if(this.elm == null) {
                    return this;
                }
                this.typeLine(row)
                .then(function() {
                    self.currentLine++;
                    if(lineCount <= self.currentLine) {
                        self.currentLine = 0;
                        if(!self.loop) {
                            self.triggerEvent(TW_EVENT_END);
                            return;
                        }
                    }
                    self.timer(self.pause, function() {
                        self.type(line);
                    });
                });
            },
            timer: function(time, callback) {
                setTimeout(function() {
                    callback();
                }, time);
            },
            typeLine: function(row) {
                var self = this;
                var wordCount = row.length;
                var style;
                this.elm.innerHTML = "";
                style = getStyle(this.elm);
                this.elm.appendChild(this.cursor);
                this.cursor.style.height = style.height;
                return new Promise(function(resolve, reject) {
                    var i = 0;
                    var a = function() {
                        if(typeof row[i] == 'undefined') {
                            resolve();
                            return;
                        }
                        new Promise(function(resolve, reject) {
                            if(row[i].nodeName.toUpperCase()=="#TEXT") {
                                let char = row[i].textContent;
                                let characters = char.length;
                                let wi = 0;
                                let charType = function() {
                                    setTimeout(function() {
                                        if(self.effect.type&&self.effect.type=="fade") {
                                            let c = document.createElement('span');
                                            c.style.opacity = 0;
                                            c.style.transition = "opacity "+self.effect.duration+"ms ease-out";
                                            c.innerHTML = char[wi];
                                            self.elm.appendChild(c);
                                            setTimeout(function(){
                                                c.style.opacity = 1;
                                            }, self.speed*0.5);
                                        } else {
                                            self.elm.innerHTML += char[wi];
                                        }
                                        self.moveCursor();
                                        wi++;
                                        if(wi < characters) {
                                            charType();
                                            return;
                                        }
                                        resolve();
                                    }, self.getRandumDelay(self.speed));
                                }
                                charType();
                            } else {
                                let _node = document.createElement(row[i].nodeName);
                                let char = row[i].textContent;
                                let characters = char.length;
                                let wi = 0;

                                if(row[i].nodeName.toUpperCase()=="A") {
                                    _node.href = row[i].href;
                                    _node.target = row[i].target;
                                }

                                let charType = function() {
                                    setTimeout(function() {
                                        if(self.effect.type&&self.effect.type=="fade") {
                                            let c = document.createElement('span');
                                            c.style.opacity = 0;
                                            c.style.transition = "opacity "+self.effect.duration+"ms ease-out";
                                            c.innerHTML = char[wi];
                                            _node.appendChild(c);
                                            setTimeout(function(){
                                                c.style.opacity = 1;
                                            }, self.speed*0.5);
                                        } else {
                                            _node.innerHTML += char[wi];
                                        }
                                        self.moveCursor();
                                        wi++;
                                        if(wi < characters) {
                                            charType();
                                            return;
                                        }
                                        resolve();
                                    }, self.getRandumDelay(self.speed));
                                }
                                _node.style.textDecoration = row[i].style.textDecoration;
                                _node.style.fontWeight = row[i].style.fontWeight;
                                _node.style.fontStyle = row[i].style.fontStyle;

                                self.elm.appendChild(_node);
                                charType();
                            }
                        }).then(function(){
                            i++;
                            if(i < wordCount) {
                                a();
                                return;
                            }
                            resolve();
                        });
                    }
                    a();
                });
            },
            moveCursor: function() {
                if(this.elm.querySelector('.tw_cursor')) {
                    if(this.elm.querySelector('.tw_cursor').remove) {
                        this.elm.querySelector('.tw_cursor').remove();
                    } else if(this.elm.querySelector('.tw_cursor').removeNode) {
                        this.elm.querySelector('.tw_cursor').removeNode();
                    }
                }
                this.elm.appendChild(this.cursor);
            },
            setSpeed: function(t) {
                this.speed = t;
            },
            setPauseTime: function(t) {
                this.pause = t;
            },
            getRandumDelay: function(max, min) {
                if(this.random) {
                    return Math.random()*(~~max-~~min) + ~~min;
                }
                return this.speed;
            },
            on: function(type, cb) {
                if(typeof cb == "function") {
                    this.elm.addEventListener(type, cb, false);
                }
            },
            triggerEvent: function(type) {
                var self = this;
                var ev = new CustomEvent(type, {
                  bubbles: true,
                  cancelable: true
                });
                ev.data = { tw: this };
                this.elm.dispatchEvent(ev);
            }
        }

        window.TypeWriter = f;
        window.dispatchEvent(new CustomEvent('extTypeWriterReady',{bubbles:true,cancelable:true}));
    }
})();
